﻿using System;
using System.Drawing;
using System.Drawing.Imaging;
using System.Runtime.InteropServices;
using System.Windows.Forms;

namespace AutohotkeyInputRecorder
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();

            IntPtr hook = SetWindowsHookEx(WH_MOUSE_LL, new HookProc(LowLevelMouseProc), GetModuleHandle(null), 0);
        }

        private void textBox1_TextChanged(object sender, EventArgs e)
        {

        }

        private enum MouseMessages
        {
            WM_LBUTTONDOWN = 0x0201,
            WM_LBUTTONUP = 0x0202,
            WM_MOUSEMOVE = 0x0200,
            WM_MOUSEWHEEL = 0x020A,
            WM_RBUTTONDOWN = 0x0204,
            WM_RBUTTONUP = 0x0205
        }

        [StructLayout(LayoutKind.Sequential)]
        private struct POINT
        {
            public int x;
            public int y;
        }

        [StructLayout(LayoutKind.Sequential)]
        private struct MSLLHOOKSTRUCT
        {
            public POINT pt;
            public uint mouseData;
            public uint flags;
            public uint time;
            public IntPtr dwExtraInfo;
        }

        static int WH_MOUSE_LL = 14;

        [System.Runtime.InteropServices.DllImport("kernel32.dll")]
        static extern IntPtr GetModuleHandle(string moduleName);

        [System.Runtime.InteropServices.DllImport("user32.dll")]
        static extern IntPtr SetWindowsHookEx(int idHook, HookProc lpfn, IntPtr hMod, uint dwThreadId);

        [System.Runtime.InteropServices.DllImport("user32.dll")]
        static extern IntPtr CallNextHookEx(IntPtr hhk, int nCode, uint wParam, IntPtr lParam);

        delegate IntPtr HookProc(int nCode, uint wParam, IntPtr lParam);
        IntPtr LowLevelMouseProc(int nCode, uint wParam, IntPtr lParam)
        {
            if (captureCheckBox.Checked)
            {
                if (nCode >= 0 && MouseMessages.WM_LBUTTONDOWN == (MouseMessages)wParam)
                {
                    MSLLHOOKSTRUCT hookStruct = (MSLLHOOKSTRUCT)Marshal.PtrToStructure(lParam, typeof(MSLLHOOKSTRUCT));

                    if (_lastTime > 0)
                    {
                        uint dt = hookStruct.time - _lastTime;

                        const uint fixedDt = 200;

                        textBox1.Text += string.Format("Sleep, {0} ;{1}{2}", fixedDt, dt, Environment.NewLine);
                    }

                    textBox1.Text += string.Format("MouseClick, Left, {0}, {1}{2}", hookStruct.pt.x, hookStruct.pt.y, Environment.NewLine);

                    //Uncomment this if you want to capture a small screen shot around the area you click. This might come in handy for
                    //setting up image searches, but it was less useful than I was hoping for since most buttons have mouse over states.
                    //CaptureScreenClickRegion(hookStruct.pt.x, hookStruct.pt.y);

                    _lastTime = hookStruct.time;
                }
            }

            return CallNextHookEx(IntPtr.Zero, nCode, wParam, lParam);
        }

        uint _lastTime = 0;

        private void clearButton_Click(object sender, EventArgs e)
        {
            textBox1.Text = "";
        }

        private void captureCheckBox_CheckedChanged(object sender, EventArgs e)
        {
            if (captureCheckBox.Checked)
            {
                _lastTime = 0;
            }
        }

        private void Form1_Load(object sender, EventArgs e)
        {

        }

        void CaptureScreenClickRegion(int clickX, int clickY)
        {
            const int captureSizeX = 20;
            const int captureSizeY = 10;
            Rectangle rect = new Rectangle(clickX - captureSizeX / 2, clickY - captureSizeY / 2, captureSizeX, captureSizeY);

            Bitmap bmp = new Bitmap(rect.Width, rect.Height, PixelFormat.Format32bppArgb);

            Graphics g = Graphics.FromImage(bmp);

            g.CopyFromScreen(rect.Left, rect.Top, 0, 0, bmp.Size, CopyPixelOperation.SourceCopy);

            string saveName = string.Format("Capture{0}.bmp", _clickCount);
            ++_clickCount;

            bmp.Save(saveName, ImageFormat.Bmp);
        }

        int _clickCount = 0;
    }
}
